import GoogleSATool

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory
from Products.GoogleSATool import config
from AccessControl import allow_module, allow_class, allow_type

try:
    from Products.GenericSetup import profile_registry
    from Products.GenericSetup import BASE, EXTENSION
    from Products.CMFPlone.interfaces import IPloneSiteRoot
except ImportError:
    profile_registry = None

googlesa_globals=globals()

# Make the skins available as DirectoryViews.
registerDirectory('skins', googlesa_globals)

def initialize(context):
    # Support backward compatible form of the initialisation call
    for extra in ({}, # Plone 2.1
        {'product_name': config.PROJECTNAME } # Plone 2.0
        ):
        try:
            init = utils.ToolInit(config.METATYPE,
                       tools=(GoogleSATool.GoogleSATool,),
                       icon="googlesa_icon.ico",
                       **extra
                       )
            break
        except TypeError:
            continue
    else:
        raise
    init.initialize(context)

    if profile_registry is not None:
        profile_registry.registerProfile('default',
                                     'Google Search Appliance',
                                     'Extension profile for searching using Google Search Appliance',
                                     'profiles/default',
                                     'GoogleSATool',
                                     EXTENSION,
                                     for_=IPloneSiteRoot)

for mod in 'GoogleResults', 'XmlWrappers', 'GoogleSATool':
    allow_module('Products.GoogleSATool.%s' % mod)
