"""GoogleSATool z3 interfaces.

$Id: interfaces.py 38715 2005-10-02 13:09:02Z yuppie $
"""

try:
    from zope.interface import Interface
except ImportError:
    class Interface:
        """A dummy interface base class"""

class IGoogleSATool(Interface):
    # Searching
    def search(context, **kwargs):
        """
        Send a request to the Google appliance.
        'context' is passed through to Python expressions when building
        the query string.
        Values passed in kwargs take precedence over values calculated
        from the tool configuration.
        
        Returns the Google result XML mapped to a set of Python classes
        i.e. a GoogleResults object.
        """

    # Formatting search results
    def make_query(url=None, **keywords):
        """Make a query string for Plone.
        Similar to ZTUtils make_query, but allows keyword=None to
        force an argument to be omitted.

        Also omits the 'submit' parameters automatically.
        """
    def getResultIcon(self, result):
        """Get an icon suitable for this result"""
    def encode(s):
        """Results are returned in unicode, this method will
        encode them to ascii converting other characters to
        character references."""
    def query_string(replace={}, original=None):
        """ Updates 'original' dictionary by the values in the 'replace'
            dictionary and returns the result as url quoted query string.

            The 'original' dictionary defaults to 'REQUEST.form' if no
            parameter is passed to it. Keys in the 'replace' dictionary
            with a value of 'None' (or _.None in DTML) will be deleted
            from 'original' dictionary before being quoted.

            The original 'REQUEST.form' will remain unchanged.
        """
    def url_plus_query(url, query=None):
        """Adds query segment to an existing URL.
        Existing query parameters are may be overridden by query,
        otherwise they are preserved.
        """
        
    def getExtraSearches():
        """Returns the canned searches as a list of dictionaries
        with keys:
        title: The canned search title.
        query: The query parameters from the configuration screen.
        decoded: A dictionary of parameters to be set or cleared in the query.
        url: The constructed URL.
        current: True if the current request could have generated this query.
        """
    def matchExtraSearch():
        """Returns the title of the current canned search, or None.
        Can be used to say 'you searched in <some collection>'
        """

    # Information and debugging
    def google_query(context, **kwargs):
        """Make a Google query string from:
            Keyword arguments (highest priority)
            REQUEST form arguments (middle)
            configured defaults (lowest)
            
            Throws GoogleError if any required arguments are missing,
            or if any keyword arguments are not configured fields.
        """
    def getGoogleURL():
        """
        Gets the Google URL
        """

class IGoogleSAToolManagement(Interface):
    def manage_setGooglePrefs(REQUEST=None,
        googleURL=None, fields=None, collectionRegex=None, searches=None):
        """
        Set the tool parameters
        """
    def getEditExtraSearches(self):
        """The canned searches for editing"""
    def getEditFieldOptions():
        '''Field options for edit screen, sorted and with a trailing blank entry.'''
    def getCollectionRegex():
        """The regular expression used to validate collection names"""
    def getFieldOptions():
        """Gets the field settings"""


