## Script (Python) "livescript_reply"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=q,limit=10
##title=Determine whether to show an id in an edit form

from Products.CMFCore.utils import getToolByName
from Products.CMFPlone import PloneMessageFactory as _
from Products.PythonScripts.standard import url_quote, html_quote

ploneUtils = getToolByName(context, 'plone_utils')
pretty_title_or_id = ploneUtils.pretty_title_or_id

portalProperties = getToolByName(context, 'portal_properties')
siteProperties = getattr(portalProperties, 'site_properties', None)
useViewAction = []
if siteProperties is not None:
    useViewAction = siteProperties.getProperty('typesUseViewActionInListings', [])

# SIMPLE CONFIGURATION
USE_ICON = True
USE_RANKING = False
MAX_TITLE = 29
MAX_DESCRIPTION = 93

# generate a result set for the query
googlesa = context.portal_googlesa

friendly_types = ploneUtils.getUserFriendlyTypes()

def quotestring(s):
    return '"%s"' % s

def quote_bad_chars(s):
    bad_chars = ["(", ")"]
    for char in bad_chars:
        s = s.replace(char, quotestring(char))
    return s

GSP = googlesa.search(context, q=q)

RESPONSE = context.REQUEST.RESPONSE
RESPONSE.setHeader('Content-Type', 'text/xml;charset=%s' % context.plone_utils.getSiteEncoding())

# replace named entities with their numbered counterparts, in the xml the named ones are not correct
#   &darr;      --> &#8595;
#   &hellip;    --> &#8230;
legend_livesearch = _('legend_livesearch', default='LiveSearch &#8595;')
label_no_results_found = _('label_no_results_found', default='No matching results found.')
label_advanced_search = _('label_advanced_search', default='Advanched Search&#8230;')
label_show_all = _('label_show_all', default='Show all&#8230;')

ts = getToolByName(context, 'translation_service')

def suggest():
    spelling = getattr(GSP, 'Spelling', None)
    if spelling is not None:
        suggestions = []
        print '''<li class="LSRow">'''
        print '''Did you mean'''
        url = context.search.absolute_url()
        for suggestion in list(spelling.Suggestion):
            suggestions.append('<a href="%s">%s</a>' % (googlesa.make_query(url=url, SearchableText=suggestion.q,q=None), str(suggestion)))
        print ','.join(suggestions)+'?'
        print '''</li>'''
    return printed

RES = getattr(GSP, 'RES', None)
if not RES:
    print '''<fieldset class="livesearchContainer">'''
    print '''<legend id="livesearchLegend">%s</legend>''' % ts.translate(legend_livesearch)
    print '''<div class="LSIEFix">'''
    print '''<div id="LSNothingFound">%s</div>''' % ts.translate(label_no_results_found)
    print suggest()
    print '''<li class="LSRow">'''
    print '<a href="search_form" style="font-weight:normal">%s</a>' % ts.translate(label_advanced_search)
    print '''</li>'''
    print '''</div>'''
    print '''</fieldset>'''

else:
    print '''<fieldset class="livesearchContainer">'''
    print '''<legend id="livesearchLegend">%s</legend>''' % ts.translate(legend_livesearch)
    print '''<div class="LSIEFix">'''
    print suggest()
    print '''<ul class="LSTable">'''

    for result in list(RES.R)[:limit]:

        itemUrl = result.U
#         if result.portal_type in useViewAction:
#             itemUrl += '/view'

        print '''<li class="LSRow">''',
        icon = googlesa.getResultIcon(result)
        if icon:
            print icon,

        full_title = result.T
        display_title = googlesa.encode(full_title)
        
        print '''<a href="%s">%s</a>''' % (itemUrl, display_title)
        # print '''<span class="discreet">[%s%%]</span>''' % result.data_record_normalized_score_
        display_description = googlesa.encode(result.S.replace('<br>',' '))
        
        print '''<div class="discreet" style="margin-left: 2.5em;">%s</div>''' % (display_description)
        print '''</li>'''
        full_title, display_title, display_description = None, None, None

    print '''<li class="LSRow">'''
    print '<a href="search_form" style="font-weight:normal">%s</a>' % ts.translate(label_advanced_search)
    print '''</li>'''

    if RES and RES.M > limit:
        # add a more... row
        print '''<li class="LSRow">'''
        print '<a href="%s" style="font-weight:normal">%s</a>' % ('search?SearchableText=' + url_quote(q), ts.translate(label_show_all))
        print '''</li>'''
    print '''</ul>'''
    print '''</div>'''
    print '''</fieldset>'''

return printed

