# -*- coding: UTF-8 -*-
################################################################################
#
# This file is based on the Archetypes file test_doctest.py
#
# Copyright (c) 2002-2005, Benjamin Saller <bcsaller@ideasuite.com>, and
#                              the respective authors. All rights reserved.
# For a list of Archetypes contributors see docs/CREDITS.txt.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# * Redistributions of source code must retain the above copyright notice, this
#   list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice,
#   this list of conditions and the following disclaimer in the documentation
#   and/or other materials provided with the distribution.
# * Neither the name of the author nor the names of its contributors may be used
#   to endorse or promote products derived from this software without specific
#   prior written permission.
#
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#
################################################################################
"""
"""

__author__ = 'Duncan Booth'
__docformat__ = 'restructuredtext'

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Testing.ZopeTestCase import FunctionalDocFileSuite as FileSuite
import unittest

# a list of dotted paths to modules which contains doc tests
# e.g. Products.GoogleSATool.utils
DOCTEST_MODULES = ()

# A list of filenames for tests in documentation.
DOCTEST_FILES = ('../doc/documentation.txt',)

from Products.GoogleSATool.tests.gsatestcase import GSAFunctionalTestCase
from Products.GoogleSATool.tests.doctestcase import ZopeDocTestSuite

def test_suite():
    suite = ZopeDocTestSuite(test_class=GSAFunctionalTestCase,
                             extraglobs={},
                             *DOCTEST_MODULES
                             )
    for file in DOCTEST_FILES:
        suite.addTest(FileSuite(file, package="Products.GoogleSATool.tests",
                                test_class=GSAFunctionalTestCase)
                     )
    return suite

if __name__ == '__main__':
    framework()
